/*************************************************************************
 * Test - (c) 1996 Philippe Castella                                     *
 * Programme de test de la librarie WindGem                              *
 *************************************************************************/

/*************************************************************************
 * Fichiers  inclure                                                    *
 *************************************************************************/
#include <WindGem.h>		/* Formulaires en fentre */
#include <xgemfast.h>
#include "test.h"				/* Dfinition des objets  */

/*************************************************************************
 * Prototypes des fonctions du programme                                 *
 *************************************************************************/
void gereMenu(int option);
void main(void);
void init_prog(void);

void informe(int evnt);
void form(int evnt);
void form1(int evnt);

/*************************************************************************
 * Paramtres de l'application                                           *
 *************************************************************************/
int finProg = FALSE;

void gerePopup (int option)
{
	switch (option)
	{
	case POP1 :
	case POP2 :
	case POP3 :
	case POP4 :
		form_alert(1,"[1][|Gestion d'un popup Menu par appui|sur la touche droite de la souris !!|][Ok]");
		break;
	}
}

void gereMenu (int option)
{
	char chemin[128], fname[13] = {0};
	int numTxt;
	GRECT Fpos;
	
	switch (option)
	{
	case MFORM :
		WindOpen(FORM);
		break;

	case MTEXTE :
		strcpy(chemin,"\\");
		if (selector (chemin, "*.*", fname, "Choisir un fichier texte"))
		{
			Fpos.g_x = 100;
			Fpos.g_y = 100;
			Fpos.g_w = 400;
			Fpos.g_h = 300;
			strcat(chemin, fname);
			numTxt = WindTextInit (chemin, &Fpos);
			WindOpen(numTxt);
		}
		break;

	case MINFO :
		WindOpen(PROGINFO);
		break;

	case MQUITTER :
		finProg = TRUE;
		break;
	}
}

/*-----------------------------------------------------------------------*/
void main(void)
/*-----------------------------------------------------------------------*
 * Fonction principale                                                   *
 * - Initialisation,                                                     *
 * - Gestion des vnements,                                             *
 * - Fin du programme.                                                   *
 *-----------------------------------------------------------------------*/
{
	int i;
	
	init_prog();

	do
	{
		EventMulti();
	} while (NOT finProg);
	AppExit();
	exit(0);
}

void init_prog(void)
{
	AppInit("Test.rsc", DESK, (void *)NULL, MENU, gereMenu);

	WindFormInit(PROGINFO, WMODAL , 0, 0, "Informations"            , 0      , informe   );
	WindFormInit(FORM    , WNORM , 0, 0, "Crer une nouvelle fiche", STIT, form);
	AjouteAide (FORM, SSAUV, "Bouton de sauvegarde|Permet de sauver les informations|de la fiche...");
	AjouteAide (FORM, SANNU, "Bouton d'annulation|Ferme la fiche sans sauvegarde|de son contenu...");
	AjouteAide (FORM, SPOP, "Bouton de popup|Permet de slectionner la catgorie|du livre...");
	AjouteAide (FORM, SAIDE, "Bouton HELP|Permet de faire appel  l'aide en ligne|enfin bientt...");

	PopMenu(POPUPM, gerePopup);

}

/*-----------------------------------------------------------------------*
 * Routines de gestion du menu                                           *
 *-----------------------------------------------------------------------*/
void informe(int evnt)
{
	int choix;
	
	if (evnt & MU_BUTTON)
	{
		choix = GetObjet();
		if (choix > 0)
		{
			ObjcUnselect (PROGINFO, choix);
			WindClose(PROGINFO);
		}
	}
}

void form(int evnt)
{
	int choix;

	if (evnt == EV_OPEN)
	{
		form_alert(1,"[1][Fonction appelee  |l'ouverture de la fenetre][Ok]");
	}		
	if (evnt == EV_CLOSE)
	{
		form_alert(1,"[1][Fonction appelee  |la fermeture de la fenetre][Ok]");
		/* ATTENTION : ne pas fermer la fenetre */
	}		
	if (evnt & MU_BUTTON)
	{
		choix = GetObjet();
		if (choix == SCAT || choix == SPOP)
		{
			pop_up (FORM, SCAT, POPUP);
		}

		if (choix == SANNU || choix == SSAUV || choix == SAIDE || choix == SPOP)
			ObjcUnselect (FORM, choix);

		if (choix == SANNU || choix == EV_CLOSE)
			WindClose(FORM);
	}
}

/*----------------------------------------------------------------------*/
